package com.example.ball.config;

import com.example.ball.config.intercepor.LoginInterceptor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;
//登录拦截器
@Configuration
public class WebConfigurer implements WebMvcConfigurer {
	//这些不会被拦截
    private final String[] notLoginInterceptPaths = {"/", "/login/**", "/doLogin/**","/register/**", "/doRegister/**","/image/**"};
    @Autowired
    private LoginInterceptor loginInterceptor;

    @Override
    public void addInterceptors(InterceptorRegistry registry){
        registry.addInterceptor(loginInterceptor).addPathPatterns("/**").excludePathPatterns(notLoginInterceptPaths);
    }
}
