package com.example.ball.controller;

import com.example.ball.pojo.Order;
import com.example.ball.pojo.User;
import com.example.ball.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.PostMapping;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Controller
public class AppointmentController {
    @Autowired
    private OrderService orderService;

    @PostMapping("makeAppointment")
    public String makeAppointment(Order order, Model model, HttpSession session){
        Map<String,Object> msg = new HashMap<>();
        User user = (User) session.getAttribute("user");
        model.addAttribute("msg", msg);

        try {
            order.setUserId(user.getId());
            if(orderService.duplicateCheck(order)){
                orderService.insert(order);
                order.setUserId(null);
                long count = orderService.templateCount(order);
                msg.put("name","订单提交成功,已预约人数：" + count);
                model.addAttribute("redirectPath", "/");
            }else {
                msg.put("name","订单重复！");
                model.addAttribute("redirectPath", "/appointment");
            }
        } catch (Exception e) {
            e.printStackTrace();
            msg.put("name","订单提交失败！");
            model.addAttribute("redirectPath", "/appointment");
        }
        return "appointment.html";
    }
    //问题
    @GetMapping("appointment")
    public String appointmentView(){
        return "appointment.html";
    }
    //表单日期字符串与Javabean中的data进行转换，手动配置
    @InitBinder
    protected void initBinder(ServletRequestDataBinder binder) {
        binder.registerCustomEditor(Date.class,
                new CustomDateEditor(new SimpleDateFormat("yyyy-MM-dd'T'HH:mm"), true));
    }
}
