package com.example.ball.controller;

import com.example.ball.pojo.Order;
import com.example.ball.pojo.User;
import com.example.ball.service.OrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;

import javax.servlet.http.HttpSession;
import java.util.List;

@Controller
public class OrderController {
    @Autowired
    private OrderService orderService;

    @GetMapping("currOrder")
    public String currOrder(Model model){
        Order order = orderService.currOrder();
        if(null != order) {
            model.addAttribute("order", order);
            Order query = new Order();
            query.setAppointmentTime(order.getAppointmentTime());
            query.setBallType(order.getBallType());
            query.setPlace(order.getPlace());
            long count = orderService.templateCount(query);
            model.addAttribute("count",count);
        }
        return "currOrder.html";
    }

    @GetMapping("cancelOrder")
    public String cancelOrder(Long id){
        orderService.deleteById(id);
        return "redirect:/currOrder";
    }
    //从数据库中取出所有这个用户的历史订单
    @GetMapping("orderList")
    public String list(HttpSession session,Model model){
        User user = (User) session.getAttribute("user");
        List<Order> list = orderService.findByUserId(user.getId());
        model.addAttribute("orders", list);
        return "orderList.html";
    }
}
