package com.example.ball.controller;

import com.example.ball.pojo.User;
import com.example.ball.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;

import javax.servlet.http.HttpSession;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Controller
public class UserController {
    @Autowired
    private UserService userService;

    private Map<String, Object> checkRegisterForm(User user, String repassword){
        Map<String, Object> error = new HashMap<>();
        if(!repassword.equals(user.getPassword())){
            error.put("name", "密码不一致");
        }
        return error;
    }
    @PostMapping("doRegister")
    public String register(User user, HttpSession session, String repassword, Model model){
        Map<String, Object> error = checkRegisterForm(user, repassword);
        if(!error.isEmpty()){
            model.addAttribute("error",error);
            return "register.html";
        }

        error = userService.registerCheck(user);

        if(!error.isEmpty()){
            model.addAttribute("error",error);
            return "register.html";
        }

        user = userService.register(user);
        session.setAttribute("user", user);
        return "redirect:/";
    }

    @GetMapping("register")
    public String registerView(){
        return "register.html";
    }

    @GetMapping("login")
    public String loginView(){
        return "login.html";
    }

    @PostMapping("/doLogin")
    public String doLogin(String username, String password, Model model, HttpSession session){
        Map<String,Object> error = new HashMap<>();
        model.addAttribute("error", error);
        User user = userService.login(username, password);
        if(null == user){
            error.put("name", "用户名或密码错误！");
            return "login.html";
        }
        session.setAttribute("user", user);
        return "redirect:/";
    }
    //问题
    @PostMapping("doUpdateProfile")
    public String doUpdateProfile(HttpSession session, User user,Integer year,Integer month,Integer day){
        Calendar c = Calendar.getInstance();
        c.set(Calendar.YEAR,year);
        c.set(Calendar.MONTH,month-1);
        c.set(Calendar.DATE, day);
        user.setBirthday(c.getTime());
        user.setId(((User) session.getAttribute("user")).getId());
        session.setAttribute("user", userService.updateTemplate(user));
        return "redirect:/profile";
    }
    //注销
    @GetMapping("logout")
    public String logout(HttpSession session){
        session.removeAttribute("user");
        return "redirect:/";
    }
    
    @GetMapping("profile")
    public String profileView(){
        return "profile.html";
    }

    @GetMapping("updateProfile")
    public String updateProfileView(){
        return "updateprofile.html";
    }
}
