package com.example.ball.service;

import com.example.ball.pojo.Order;
import org.beetl.sql.core.SQLManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class OrderService {
    @Autowired
    private SQLManager sqlManager;

    public void insert(Order order){
        order.setCreated(new Date());
        sqlManager.insert(order);
    }

    public boolean duplicateCheck(Order order){
        List<Order> template = sqlManager.template(order);
        return template.isEmpty();
    }

    public long templateCount(Order order) {
        return sqlManager.templateCount(order);
    }

    public Order currOrder() {
        return sqlManager.templateOne(new Order());
    }

    public void deleteById(Long id) {
        sqlManager.deleteById(Order.class, id);
    }

    public List<Order> findByUserId(Long userId) {
        Order query = new Order();
        query.setUserId(userId);
        return sqlManager.template(query);
    }
}
