package com.example.ball.service;

import com.example.ball.pojo.User;
import org.beetl.sql.core.SQLManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Service
public class UserService {
    @Autowired
    private SQLManager sqlManager;//获得SQLmanager

    public Map<String,Object> registerCheck(User user){
        Map<String,Object> error = new HashMap<>();
        User query;
        query = new User();
        query.setName(user.getName());
        if(sqlManager.templateOne(query) != null){//逐步验证
            error.put("name", "用户名已存在！");
        }
        query = new User();
        query.setEmail(user.getEmail());
        if(sqlManager.templateOne(query) != null){
            error.put("email", "邮箱已存在！");
        }
        query = new User();
        query.setPhone(user.getPhone());
        if(sqlManager.templateOne(query) != null){
            error.put("name", "手机号已存在！");
        }
        return error;
    }

    public User register(User user){
        sqlManager.insert(user);
        return user;
    }

    public User login(String username, String password) {
        User query = new User();
        query.setName(username);
        query.setPassword(password);
        User user = sqlManager.templateOne(query);//用户名登录
        if(user == null){
            query.setEmail(null);
            query.setName(null);
            query.setPhone(username);//手机号登录
        }
        user = sqlManager.templateOne(query);

        if(user == null){
            query.setPhone(null);
            query.setName(null);
            query.setEmail(username);//邮箱登录
        }
        user = sqlManager.templateOne(query);//查询返回一个user

        return user;
    }

    public User updateTemplate(User user) {//根据主键id更新
        sqlManager.updateTemplateById(user);
        return sqlManager.single(User.class, user.getId());
    }
}
